import picklepie as __pp
from sklearn.ensemble import RandomForestClassifier as __model

class params :
    n_estimators = 100 # int, default=100
    criterion = 'gini' # {“gini”, “entropy”}, default=”gini”
    max_depth = None # int, default=None
    min_samples_split = 2 # int or float, default=2
    min_samples_leaf = 1 # int or float, default=1
    min_weight_fraction_leaf = 0.0 # float, default=0.0
    max_features = 'auto' # {“auto”, “sqrt”, “log2”}, int or float, default=”auto”
    max_leaf_nodes = None # int, default=None
    min_impurity_decrease = 0.0 # float, default=0.0
    min_impurity_split = None # float, default=None
    bootstrap = True # bool, default=True
    oob_score = False # bool, default=False
    n_jobs = 1 # int, default=None
    random_state = None # int, RandomState instance or None, default=None
    verbose = 0 # int, default=0
    warm_start = False # bool, default=False
    class_weight = None # {“balanced”, “balanced_subsample”}, dict or list of dicts, default=None
    ccp_alpha = 0.0 # non-negative float, default=0.0
    max_samples = None # int or float, default=None

def __modeler (b_params='') :
    if (b_params == '') :
        loc_params = params
    else :
        loc_params = b_params
    if (b_params != False) :
        loc_modeler = __model( \
            n_estimators = loc_params.n_estimators, \
            criterion = loc_params.criterion, \
            max_depth = loc_params.max_depth, \
            min_samples_split = loc_params.min_samples_split, \
            min_samples_leaf = loc_params.min_samples_leaf, \
            min_weight_fraction_leaf = loc_params.min_weight_fraction_leaf, \
            max_features = loc_params.max_features, \
            max_leaf_nodes = loc_params.max_leaf_nodes, \
            min_impurity_decrease = loc_params.min_impurity_decrease, \
            min_impurity_split = loc_params.min_impurity_split, \
            bootstrap = loc_params.bootstrap, \
            oob_score = loc_params.oob_score, \
            n_jobs = loc_params.n_jobs, \
            random_state = loc_params.random_state, \
            verbose = loc_params.verbose, \
            warm_start = loc_params.warm_start, \
            class_weight = loc_params.class_weight, \
            ccp_alpha = loc_params.ccp_alpha, \
            max_samples = loc_params.max_samples, \
        )
    else :
        loc_modeler = __model()
    return loc_modeler

def fit (a_data,b_params='',b_threshold=0.5) :
    loc_modeler = __modeler(b_params=b_params)
    return __pp.mlearn.classification.__base.__run(loc_modeler,a_x_train=a_data.x_train,a_x_test=a_data.x_test,a_y_train=a_data.y_train,a_y_test=a_data.y_test,b_threshold=b_threshold)

def bagging (a_data,b_params='') :
    loc_modeler = __modeler(b_params=b_params)
    return __pp.mlearn.classification.__base.__bagging(loc_modeler,a_data,b_params)

def grid_search_cv (a_data,b_params) :
    loc_modeler = __modeler(b_params=b_params)
    return __pp.mlearn.classification.__base.__grid_search_cv(loc_modeler,a_data,b_params)

def predict (a_model,a_data,b_features='',b_threshold=0.5) :
    return __pp.mlearn.classification.__base.__predict(a_model=a_model,a_data=a_data,b_features=b_features,b_threshold=b_threshold)

